#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "forms.h"
#include "turnoff.h"
#include "turnon.h"

/* COLOURS */
#define RED 1
#define GREEN 2
#define BLUE 3
#define PURPLE 4

void v_form(int** matrix, int* index)
{
	int i = 0, j = 0;
	for (i = 0; i < 3; i++)
	{
		j = 0;
		
		tonLED31(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED31(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED22(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED22(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED13(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED13(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED24(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED24(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED35(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED35(matrix[j][index[j]]);
		turnOffTheLEDs();
	}
}

void a_form(int** matrix, int* index)
{
	int i = 0, j = 0;
	for (i = 0; i < 3; i++)
	{
		j = 0;
		
		tonLED11(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED11(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED22(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED22(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED33(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED33(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED24(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED24(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED15(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED15(matrix[j][index[j]]);
		turnOffTheLEDs();
	}
}

void line1_form(int** matrix, int* index)
{
	int i = 0, j = 0;
	for (i = 0; i < 3; i++)
	{
		j = 0;
		
		tonLED11(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED11(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED12(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED12(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED13(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED13(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED14(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED14(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED15(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED15(matrix[j][index[j]]);
		turnOffTheLEDs();
	}
}

void line2_form(int** matrix, int* index)
{
	int i = 0, j = 0;
	for (i = 0; i < 3; i++)
	{
		j = 0;
		
		tonLED21(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED21(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED22(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED22(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED23(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED23(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED24(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED24(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED25(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED25(matrix[j][index[j]]);
		turnOffTheLEDs();
	}
}

void line3_form(int** matrix, int* index)
{
	int i = 0, j = 0;
	for (i = 0; i < 3; i++)
	{
		j = 0;
		
		tonLED31(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED31(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED32(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED32(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED33(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED33(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED34(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED34(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED35(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED35(matrix[j][index[j]]);
		turnOffTheLEDs();
	}
}

void line1_2_form(int** matrix, int* index)
{
	int i = 0, j = 0;
	for (i = 0; i < 3; i++)
	{
		j = 0;
		
		tonLED11(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED11(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED12(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED12(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED23(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED23(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED14(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED14(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED15(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED15(matrix[j][index[j]]);
		turnOffTheLEDs();
	}
}

void line3_2_form(int** matrix, int* index)
{
	int i = 0, j = 0;
	for (i = 0; i < 3; i++)
	{
		j = 0;
		
		tonLED31(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED31(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED32(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED32(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED23(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED23(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED34(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED34(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED35(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED35(matrix[j][index[j]]);
		turnOffTheLEDs();
	}
}

void line2_1_form(int** matrix, int* index)
{
	int i = 0, j = 0;
	for (i = 0; i < 3; i++)
	{
		j = 0;
		
		tonLED21(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED21(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED12(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED12(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED13(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED13(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED14(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED14(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED25(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED25(matrix[j][index[j]]);
		turnOffTheLEDs();
	}
}

void line2_3_form(int** matrix, int* index)
{
	int i = 0, j = 0;
	for (i = 0; i < 3; i++)
	{
		j = 0;
		
		tonLED21(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED21(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED32(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED32(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED33(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED33(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED34(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED34(matrix[j][index[j]]);
		turnOffTheLEDs();
		j++;
		
		tonLED25(matrix[j][index[j]]);
		_delay_ms(200);
		toffLED25(matrix[j][index[j]]);
		turnOffTheLEDs();
	}
}

int check_form(int** matrix, int* index)
{
	int i = 0;
	/* first LED */
	int prev_colour = matrix[i][index[i]];
	i++;
	
	/* check second LED */
	if (matrix[i][index[i]] != prev_colour)
	{
		return 0;
	}
	i++;
	
	/* check third LED */
	if (matrix[i][index[i]] != prev_colour)
	{
		if (prev_colour == RED)
		{
			return i;
		}
		return 0;
	}
	i++;
	
	/* check fourth LED */
	if (matrix[i][index[i]] != prev_colour)
	{
		return i;
	}
	i++;
	
	/* check fifth LED */
	if (matrix[i][index[i]] != prev_colour)
	{
		return i;
	}
	i++;
	
	return i;
}
