#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "turnoff.h"

void toffLED11(int colour)
{
	PORTA |= (1 << PA0);
	switch (colour)
	{
		case 1://RED
			PORTB &= ~(1 << PB7);
			break;
		case 2://GREEN//GREEN
			PORTB &= ~(1 << PB6);
			break;
		case 3://BLUE//BLUE
			PORTB &= ~(1 << PB5);
			break;
		case 4://PURPLE
			PORTB &= ~(1 << PB7);
			PORTB &= ~(1 << PB5);
			break;
	}
}

void toffLED12(int colour)
{
	PORTA |= (1 << PA1);
	switch (colour)
	{
		case 1://RED
			PORTB &= ~(1 << PB7);
			break;
		case 2://GREEN//GREEN
			PORTB &= ~(1 << PB6);
			break;
		case 3://BLUE//BLUE
			PORTB &= ~(1 << PB5);
			break;
		case 4://PURPLE
			PORTB &= ~(1 << PB7);
			PORTB &= ~(1 << PB5);
			break;
	}
}

void toffLED13(int colour)
{
	PORTA |= (1 << PA2);
	switch (colour)
	{
		case 1://RED
			PORTB &= ~(1 << PB7);
			break;
		case 2://GREEN//GREEN
			PORTB &= ~(1 << PB6);
			break;
		case 3://BLUE//BLUE
			PORTB &= ~(1 << PB5);
			break;
		case 4://PURPLE
			PORTB &= ~(1 << PB7);
			PORTB &= ~(1 << PB5);
			break;
	}
}

void toffLED14(int colour)
{
	PORTA |= (1 << PA3);
	switch (colour)
	{
		case 1://RED
			PORTB &= ~(1 << PB7);
			break;
		case 2://GREEN//GREEN
			PORTB &= ~(1 << PB6);
			break;
		case 3://BLUE//BLUE
			PORTB &= ~(1 << PB5);
			break;
		case 4://PURPLE
			PORTB &= ~(1 << PB7);
			PORTB &= ~(1 << PB5);
			break;
	}
}

void toffLED15(int colour)
{
	PORTA |= (1 << PA4);
	switch (colour)
	{
		case 1://RED
			PORTB &= ~(1 << PB7);
			break;
		case 2://GREEN//GREEN
			PORTB &= ~(1 << PB6);
			break;
		case 3://BLUE//BLUE
			PORTB &= ~(1 << PB5);
			break;
		case 4://PURPLE
			PORTB &= ~(1 << PB7);
			PORTB &= ~(1 << PB5);
			break;
	}
}

void toffLED21(int colour)
{
	PORTA |= (1 << PA0);
	switch (colour)
	{
		case 1://RED
			PORTB &= ~(1 << PB4);
			break;
		case 2://GREEN
			PORTB &= ~(1 << PB3);
			break;
		case 3://BLUE
			PORTB &= ~(1 << PB2);
			break;
		case 4://PURPLE
			PORTB &= ~(1 << PB7);
			PORTB &= ~(1 << PB5);
			break;
	}
}

void toffLED22(int colour)
{
	PORTA |= (1 << PA1);
	switch (colour)
	{
		case 1://RED
			PORTB &= ~(1 << PB4);
			break;
		case 2://GREEN
			PORTB &= ~(1 << PB3);
			break;
		case 3://BLUE
			PORTB &= ~(1 << PB2);
			break;
		case 4://PURPLE
			PORTB &= ~(1 << PB7);
			PORTB &= ~(1 << PB5);
			break;
	}
}

void toffLED23(int colour)
{
	PORTA |= (1 << PA2);
	switch (colour)
	{
		case 1://RED
			PORTB &= ~(1 << PB4);
			break;
		case 2://GREEN
			PORTB &= ~(1 << PB3);
			break;
		case 3://BLUE
			PORTB &= ~(1 << PB2);
			break;
		case 4://PURPLE
			PORTB &= ~(1 << PB7);
			PORTB &= ~(1 << PB5);
			break;
	}
}

void toffLED24(int colour)
{
	PORTA |= (1 << PA3);
	switch (colour)
	{
		case 1://RED
			PORTB &= ~(1 << PB4);
			break;
		case 2://GREEN
			PORTB &= ~(1 << PB3);
			break;
		case 3://BLUE
			PORTB &= ~(1 << PB2);
			break;
		case 4://PURPLE
			PORTB &= ~(1 << PB7);
			PORTB &= ~(1 << PB5);
			break;
	}
}

void toffLED25(int colour)
{
	PORTA |= (1 << PA4);
	switch (colour)
	{
		case 1://RED
			PORTB &= ~(1 << PB4);
			break;
		case 2://GREEN
			PORTB &= ~(1 << PB3);
			break;
		case 3://BLUE
			PORTB &= ~(1 << PB2);
			break;
		case 4://PURPLE
			PORTB &= ~(1 << PB7);
			PORTB &= ~(1 << PB5);
			break;
	}
}

void toffLED31(int colour)
{
	PORTA |= (1 << PA0);
	switch (colour)
	{
		case 1://RED
			PORTB &= ~(1 << PB1);
			break;
		case 2://GREEN
			PORTB &= ~(1 << PB0);
			break;
		case 3://BLUE
			PORTD &= ~(1 << PD6);
			break;
		case 4://PURPLE
			PORTB &= ~(1 << PB7);
			PORTB &= ~(1 << PB5);
			break;
	}
}

void toffLED32(int colour)
{
	PORTA |= (1 << PA1);
	switch (colour)
	{
		case 1://RED
			PORTB &= ~(1 << PB1);
			break;
		case 2://GREEN
			PORTB &= ~(1 << PB0);
			break;
		case 3://BLUE
			PORTD &= ~(1 << PD6);
			break;
		case 4://PURPLE
			PORTB &= ~(1 << PB7);
			PORTB &= ~(1 << PB5);
			break;
	}
}

void toffLED33(int colour)
{
	PORTA |= (1 << PA2);
	switch (colour)
	{
		case 1://RED
			PORTB &= ~(1 << PB1);
			break;
		case 2://GREEN
			PORTB &= ~(1 << PB0);
			break;
		case 3://BLUE
			PORTD &= ~(1 << PD6);
			break;
		case 4://PURPLE
			PORTB &= ~(1 << PB7);
			PORTB &= ~(1 << PB5);
			break;
	}
}

void toffLED34(int colour)
{
	PORTA |= (1 << PA3);
	switch (colour)
	{
		case 1://RED
			PORTB &= ~(1 << PB1);
			break;
		case 2://GREEN
			PORTB &= ~(1 << PB0);
			break;
		case 3://BLUE
			PORTD &= ~(1 << PD6);
			break;
		case 4://PURPLE
			PORTB &= ~(1 << PB7);
			PORTB &= ~(1 << PB5);
			break;
	}
}

void toffLED35(int colour)
{
	PORTA |= (1 << PA4);
	switch (colour)
	{
		case 1://RED
			PORTB &= ~(1 << PB1);
			break;
		case 2://GREEN
			PORTB &= ~(1 << PB0);
			break;
		case 3://BLUE
			PORTD &= ~(1 << PD6);
			break;
		case 4://PURPLE
			PORTB &= ~(1 << PB7);
			PORTB &= ~(1 << PB5);
			break;
	}
}

void turnOffCathods()
{
	/*CATOD*/
	PORTA &= ~(1 << PA0);
	PORTA &= ~(1 << PA1);
	PORTA &= ~(1 << PA2);
	PORTA &= ~(1 << PA3);
	PORTA &= ~(1 << PA4);
}

void turnOffTheLEDs()
{
	turnOnCathods();
	
	/*RED*/
	PORTB &= ~(1 << PB1);
	PORTB &= ~(1 << PB4);
	PORTB &= ~(1 << PB7);
	/*GREEN*/
	PORTB &= ~(1 << PB0);
	PORTB &= ~(1 << PB3);
	PORTB &= ~(1 << PB6);
	/*BLUE*/
	PORTD &= ~(1 << PD6);
	PORTB &= ~(1 << PB2);
	PORTB &= ~(1 << PB5);
}

void turnOffLine(int line_number, int colour)
{
	switch (line_number)
	{
		case 1:
			toffLED11(colour);
			toffLED12(colour);
			toffLED13(colour);
			toffLED14(colour);
			toffLED15(colour);
			break;
		case 2://GREEN
			toffLED21(colour);
			toffLED22(colour);
			toffLED23(colour);
			toffLED24(colour);
			toffLED25(colour);
			break;
		case 3://BLUE
			toffLED31(colour);
			toffLED32(colour);
			toffLED33(colour);
			toffLED34(colour);
			toffLED35(colour);
			break;
	}
}

void turnOffBuzzer()
{
	PORTD &= ~(1 << PD5);
}