#ifndef _UTILS_H_
#define _UTILS_H_

#define F_CPU 16000000
#include <avr/io.h>
#include <util/delay.h>
#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "double_game.h"
#include "game.h"
#include "turnoff.h"
#include "turnon.h"
#include "lcd.h"
#include "display.h"
#include "forms.h"
#include "init.h"
#include "buzzer.h"

/* COLOURS MACROS */
#define RED 1
#define GREEN 2
#define BLUE 3
#define PURPLE 4

/* MODES MACROS */
#define BASIC_MODE "    BSC"
#define DOUBLE_MODE "    DBL"

/* MAIN MACROS */
#define GET_MONEY PD0
#define INC PD1
#define DEC PC1
#define START PD3
#define DOUBLE PD4
#define FALSE 0
#define TRUE 1

/* DISPLAY POS MACROS */
#define POS_MODE				0x49
#define POS_BET					0x44
#define POS_SOLD				0x05
#define POS_BEGIN_TOP_LINE		0x00
#define POS_BEGIN_BOTTOM_LINE	0x40
#define POS_FINAL				0x50

/* DOUBLE GAME MACROS */
#define DRED PC1
#define DBLUE PD1
#define DGET PD0

//int game_on(int bet, int** matrix, int* allocated);

#endif // _UTILS_H_