#include <avr/io.h>
#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "turnon.h"
#include "turnoff.h"

void tonLED11(int colour)
{
	PORTA &= ~(1 << PA0);
	switch (colour)
	{
		case 1://RED
			PORTB |= (1 << PB7);
			break;
		case 2://GREEN
			PORTB |= (1 << PB6);
			break;
		case 3://BLUE
			PORTB |= (1 << PB5);
			break;
		case 4://PURPLE
			PORTB |= (1 << PB7);
			PORTB |= (1 << PB5);
			break;
	}
}

void tonLED12(int colour)
{
	PORTA &= ~(1 << PA1);
	switch (colour)
	{
		case 1://RED
			PORTB |= (1 << PB7);
			break;
		case 2://GREEN
			PORTB |= (1 << PB6);
			break;
		case 3://BLUE
			PORTB |= (1 << PB5);
			break;
		case 4://PURPLE
			PORTB |= (1 << PB7);
			PORTB |= (1 << PB5);
			break;
	}
}

void tonLED13(int colour)
{
	PORTA &= ~(1 << PA2);
	switch (colour)
	{
		case 1://RED
			PORTB |= (1 << PB7);
			break;
		case 2://GREEN
			PORTB |= (1 << PB6);
			break;
		case 3://BLUE
			PORTB |= (1 << PB5);
			break;
		case 4://PURPLE
			PORTB |= (1 << PB7);
			PORTB |= (1 << PB5);
			break;
	}
}

void tonLED14(int colour)
{
	PORTA &= ~(1 << PA3);
	switch (colour)
	{
		case 1://RED
			PORTB |= (1 << PB7);
			break;
		case 2://GREEN
			PORTB |= (1 << PB6);
			break;
		case 3://BLUE
			PORTB |= (1 << PB5);
			break;
		case 4://PURPLE
			PORTB |= (1 << PB7);
			PORTB |= (1 << PB5);
			break;
	}
}

void tonLED15(int colour)
{
	PORTA &= ~(1 << PA4);
	switch (colour)
	{
		case 1://RED
			PORTB |= (1 << PB7);
			break;
		case 2://GREEN
			PORTB |= (1 << PB6);
			break;
		case 3://BLUE
			PORTB |= (1 << PB5);
			break;
		case 4://PURPLE
			PORTB |= (1 << PB7);
			PORTB |= (1 << PB5);
			break;
	}
}

void tonLED21(int colour)
{
	PORTA &= ~(1 << PA0);
	switch (colour)
	{
		case 1://RED
			PORTB |= (1 << PB4);
			break;
		case 2://GREEN
			PORTB |= (1 << PB3);
			break;
		case 3://BLUE
			PORTB |= (1 << PB2);
			break;
		case 4://PURPLE
			PORTB |= (1 << PB4);
			PORTB |= (1 << PB2);
			break;
	}
}

void tonLED22(int colour)
{
	PORTA &= ~(1 << PA1);
	switch (colour)
	{
		case 1://RED
			PORTB |= (1 << PB4);
			break;
		case 2://GREEN
			PORTB |= (1 << PB3);
			break;
		case 3://BLUE
			PORTB |= (1 << PB2);
			break;
		case 4://PURPLE
			PORTB |= (1 << PB4);
			PORTB |= (1 << PB2);
			break;
	}
}

void tonLED23(int colour)
{
	PORTA &= ~(1 << PA2);
	switch (colour)
	{
		case 1://RED
			PORTB |= (1 << PB4);
			break;
		case 2://GREEN
			PORTB |= (1 << PB3);
			break;
		case 3://BLUE
			PORTB |= (1 << PB2);
			break;
		case 4://PURPLE
			PORTB |= (1 << PB4);
			PORTB |= (1 << PB2);
			break;
	}
}

void tonLED24(int colour)
{
	PORTA &= ~(1 << PA3);
	switch (colour)
	{
		case 1://RED
			PORTB |= (1 << PB4);
			break;
		case 2://GREEN
			PORTB |= (1 << PB3);
			break;
		case 3://BLUE
			PORTB |= (1 << PB2);
			break;
		case 4://PURPLE
			PORTB |= (1 << PB4);
			PORTB |= (1 << PB2);
			break;
	}
}

void tonLED25(int colour)
{
	PORTA &= ~(1 << PA4);
	switch (colour)
	{
		case 1://RED
			PORTB |= (1 << PB4);
			break;
		case 2://GREEN
			PORTB |= (1 << PB3);
			break;
		case 3://BLUE
			PORTB |= (1 << PB2);
			break;
		case 4://PURPLE
			PORTB |= (1 << PB4);
			PORTB |= (1 << PB2);
			break;
	}
}

void tonLED31(int colour)
{
	PORTA &= ~(1 << PA0);
	switch (colour)
	{
		case 1://RED
			PORTB |= (1 << PB1);
			break;
		case 2://GREEN
			PORTB |= (1 << PB0);
			break;
		case 3://BLUE
			PORTD |= (1 << PD6);
			break;
		case 4://PURPLE
			PORTB |= (1 << PB1);
			PORTD |= (1 << PD6);
			break;
	}
}

void tonLED32(int colour)
{
	PORTA &= ~(1 << PA1);
	switch (colour)
	{
		case 1://RED
			PORTB |= (1 << PB1);
			break;
		case 2://GREEN
			PORTB |= (1 << PB0);
			break;
		case 3://BLUE
			PORTD |= (1 << PD6);
			break;
		case 4://PURPLE
			PORTB |= (1 << PB1);
			PORTD |= (1 << PD6);
			break;
	}
}

void tonLED33(int colour)
{
	PORTA &= ~(1 << PA2);
	switch (colour)
	{
		case 1://RED
			PORTB |= (1 << PB1);
			break;
		case 2://GREEN
			PORTB |= (1 << PB0);
			break;
		case 3://BLUE
			PORTD |= (1 << PD6);
			break;
		case 4://PURPLE
			PORTB |= (1 << PB1);
			PORTD |= (1 << PD6);
			break;
	}
}

void tonLED34(int colour)
{
	PORTA &= ~(1 << PA3);
	switch (colour)
	{
		case 1://RED
			PORTB |= (1 << PB1);
			break;
		case 2://GREEN
			PORTB |= (1 << PB0);
			break;
		case 3://BLUE
			PORTD |= (1 << PD6);
			break;
		case 4://PURPLE
			PORTB |= (1 << PB1);
			PORTD |= (1 << PD6);
			break;
	}
}

void tonLED35(int colour)
{
	PORTA &= ~(1 << PA4);
	switch (colour)
	{
		case 1://RED
			PORTB |= (1 << PB1);
			break;
		case 2://GREEN
			PORTB |= (1 << PB0);
			break;
		case 3://BLUE
			PORTD |= (1 << PD6);
			break;
		case 4://PURPLE
			PORTB |= (1 << PB1);
			PORTD |= (1 << PD6);
			break;
	}
}

void turnOnCathods(void)
{
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	PORTA |= (1 << PA4);
}

void turnOnTheLEDs(void)
{
	turnOffCathods();
	PORTD |= (1 << PD6);
	PORTB |= (1 << PB7);
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB5);
	PORTB |= (1 << PB4);
	PORTB |= (1 << PB3);
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB0);
}

void turnOnLine(int line_number, int colour)
{
	switch (line_number)
	{
		case 1:
			tonLED11(colour);
			tonLED12(colour);
			tonLED13(colour);
			tonLED14(colour);
			tonLED15(colour);
			break;
		case 2:
			tonLED21(colour);
			tonLED22(colour);
			tonLED23(colour);
			tonLED24(colour);
			tonLED25(colour);
			break;
		case 3:
			tonLED31(colour);
			tonLED32(colour);
			tonLED33(colour);
			tonLED34(colour);
			tonLED35(colour);
			break;
	}
}

void turnOnMatrix(int** matrix)
{
	int i = 0;
	for (i = 0; i < 180; i++)
	{
		tonLED31(matrix[0][0]);
		tonLED21(matrix[0][1]);
		tonLED11(matrix[0][2]);
		_delay_ms(3);
		turnOffTheLEDs();
		
		tonLED32(matrix[1][0]);
		tonLED22(matrix[1][1]);
		tonLED12(matrix[1][2]);
		_delay_ms(3);
		turnOffTheLEDs();
		
		tonLED33(matrix[2][0]);
		tonLED23(matrix[2][1]);
		tonLED13(matrix[2][2]);
		_delay_ms(3);
		turnOffTheLEDs();
		
		tonLED34(matrix[3][0]);
		tonLED24(matrix[3][1]);
		tonLED14(matrix[3][2]);
		_delay_ms(3);
		turnOffTheLEDs();
		
		tonLED35(matrix[4][0]);
		tonLED25(matrix[4][1]);
		tonLED15(matrix[4][2]);
		_delay_ms(3);
		turnOffTheLEDs();
	}	
}

void turnOnBuzzer()
{
	PORTD |= (1 << PD5);
}

void blink_col1(int* col)
{
	tonLED31(col[0]);
	tonLED21(col[1]);
	tonLED11(col[2]);
	_delay_ms(150);
	turnOffTheLEDs();
}

void blink_col2(int* col)
{
	tonLED32(col[0]);
	tonLED22(col[1]);
	tonLED12(col[2]);
	_delay_ms(150);
	turnOffTheLEDs();
}

void blink_col3(int* col)
{
	tonLED33(col[0]);
	tonLED23(col[1]);
	tonLED13(col[2]);
	_delay_ms(150);
	turnOffTheLEDs();
}

void blink_col4(int* col)
{
	tonLED34(col[0]);
	tonLED24(col[1]);
	tonLED14(col[2]);
	_delay_ms(150);
	turnOffTheLEDs();
}

void blink_col5(int* col)
{
	tonLED35(col[0]);
	tonLED25(col[1]);
	tonLED15(col[2]);
	_delay_ms(150);
	turnOffTheLEDs();
}